/// <reference types="node" />
import { EventEmitter } from 'events';
import Rest from './Rest/index';
import { User } from './Collections/User';
import { ClientUser } from './Types/ClientUser';
import { House } from './Collections/House';
import { Member } from './Collections/Member';
import { Message } from './Collections/Message';
import { Room } from './Collections/Room';
export declare let rest: Rest;
export declare let client: Client;
interface ClientOptions {
    type: string;
}
export declare class Client extends EventEmitter {
    private ws;
    private rest;
    users: User;
    rooms: Room;
    houses: House;
    members: Member;
    messages: Message;
    options: any;
    user: ClientUser | undefined;
    token: string | undefined;
    constructor(options?: ClientOptions);
    Connect(token: string): Promise<boolean>;
    destroy(): Promise<void>;
}
export {};
