"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Message = void 0;
// Collection Base
const BaseCollection_1 = require("./BaseCollection");
const Client_1 = require("../Client");
// Message class
class Message extends BaseCollection_1.BaseCollection {
    constructor(client) {
        super();
        this.client = client;
    }
    Collect(key, value) {
        if (typeof value == 'object') {
            value.Remove = this.Remove;
            value.Edit = this.Edit;
        }
        super.set(key, value);
        return super.get(key);
    }
    Delete(key) {
        super.delete(key);
    }
    Remove() {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            let deleteMessage = yield Client_1.rest.delete(`/rooms/${(_a = this.room) === null || _a === void 0 ? void 0 : _a.id}/messages/${this.id}`);
            return deleteMessage;
        });
    }
    Edit(content) {
        var _a;
        return __awaiter(this, void 0, void 0, function* () {
            let editMessage = yield Client_1.rest.patch(`/rooms/${(_a = this.room) === null || _a === void 0 ? void 0 : _a.id}/messages/${this.id}`, { data: { content } });
            return editMessage;
        });
    }
}
exports.Message = Message;
//# sourceMappingURL=Message.js.map