"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Room = void 0;
// Collection Base
const BaseCollection_1 = require("./BaseCollection");
const Client_1 = require("../Client");
class Room extends BaseCollection_1.BaseCollection {
    constructor(client) {
        super();
        this.id = '';
        this.name = '';
        this.Create = (name) => __awaiter(this, void 0, void 0, function* () {
            var _a, _b;
            if (!this.id)
                throw 'cannot_call_without_house';
            if (!name)
                throw 'missing_name';
            // Create Room
            let createRoom = yield Client_1.rest.post(`/houses/${this.id}/rooms`, {
                data: { name }
            });
            if (!createRoom)
                throw 'failed_to_create_room';
            (_b = (_a = this.house) === null || _a === void 0 ? void 0 : _a.rooms) === null || _b === void 0 ? void 0 : _b.Collect(createRoom.id, {
                id: createRoom.id,
                name: createRoom.name,
                house: this,
                position: createRoom.position,
                type: createRoom.type
            });
            return yield this.client.rooms.Collect(createRoom.id, {
                id: createRoom.id,
                name: createRoom.name,
                house: this,
                position: createRoom.position,
                type: createRoom.type
            });
        });
        this.client = client;
    }
    /**
     *
     * @param {string} key Object key
     * @param {value} value Object value
     */
    Collect(key, value) {
        const _super = Object.create(null, {
            set: { get: () => super.set },
            get: { get: () => super.get }
        });
        return __awaiter(this, void 0, void 0, function* () {
            if (typeof value == 'object') {
                value.Send = this.Send;
                value.Delete = this.Delete;
            }
            _super.set.call(this, key, value);
            return _super.get.call(this, key);
        });
    }
    /**
     * Send function to send message to room
     * @param {string} content Message contents
     */
    Send(content) {
        var _a, _b, _c, _d;
        return __awaiter(this, void 0, void 0, function* () {
            let sendMessage = yield Client_1.rest.post(`/rooms/${this.id}/messages`, {
                data: { content }
            });
            let message = {
                id: sendMessage.id,
                content: sendMessage.content,
                timestamp: new Date(sendMessage.timestamp),
                room: (_a = this.client) === null || _a === void 0 ? void 0 : _a.rooms.get(sendMessage.room_id),
                house: (_b = this.client) === null || _b === void 0 ? void 0 : _b.houses.get(sendMessage.house_id),
                author: (_c = this.client) === null || _c === void 0 ? void 0 : _c.users.get(sendMessage.author_id)
            };
            let collect = yield ((_d = this.client) === null || _d === void 0 ? void 0 : _d.messages.Collect(message.id, message));
            return collect;
        });
    }
    Delete() {
        return __awaiter(this, void 0, void 0, function* () {
            let deleteRoom = yield Client_1.rest.delete(`/houses/${this.id}/rooms/${this.id}`);
            return deleteRoom;
        });
    }
}
exports.Room = Room;
//# sourceMappingURL=Room.js.map